package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * MacFilteringGeneralSetting
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class MacFilteringGeneralSetting   {
  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("filterMode")
  private Integer filterMode;

  @JsonProperty("direction")
  private GatewayDirectionEntity direction;

  public MacFilteringGeneralSetting enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * Enable of the MAC filtering general setting.
   * @return enable
  */
  @ApiModelProperty(required = true, value = "Enable of the MAC filtering general setting.")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public MacFilteringGeneralSetting filterMode(Integer filterMode) {
    this.filterMode = filterMode;
    return this;
  }

  /**
   * Filter mode should be a value as follows: 0: allow; 1: deny.
   * @return filterMode
  */
  @ApiModelProperty(value = "Filter mode should be a value as follows: 0: allow; 1: deny.")


  public Integer getFilterMode() {
    return filterMode;
  }

  public void setFilterMode(Integer filterMode) {
    this.filterMode = filterMode;
  }

  public MacFilteringGeneralSetting direction(GatewayDirectionEntity direction) {
    this.direction = direction;
    return this;
  }

  /**
   * Get direction
   * @return direction
  */
  @ApiModelProperty(value = "")

  @Valid

  public GatewayDirectionEntity getDirection() {
    return direction;
  }

  public void setDirection(GatewayDirectionEntity direction) {
    this.direction = direction;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MacFilteringGeneralSetting macFilteringGeneralSetting = (MacFilteringGeneralSetting) o;
    return Objects.equals(this.enable, macFilteringGeneralSetting.enable) &&
        Objects.equals(this.filterMode, macFilteringGeneralSetting.filterMode) &&
        Objects.equals(this.direction, macFilteringGeneralSetting.direction);
  }

  @Override
  public int hashCode() {
    return Objects.hash(enable, filterMode, direction);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MacFilteringGeneralSetting {\n");
    
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    filterMode: ").append(toIndentedString(filterMode)).append("\n");
    sb.append("    direction: ").append(toIndentedString(direction)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

